WinStd Additional templates and function helpers for Microsoft Windows using Standard C++ classes

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
winstd::window_dc Class Reference
GDI API

Device context wrapper class. More...

`#include <GDI.h>`

Inheritance diagram for winstd::window_dc:

## Public Member Functions
| window_dc (_In_opt_ handle_type h, _In_opt_ HWND hwnd) noexcept
| window_dc (_Inout_ window_dc &&h) noexcept
window_dc & | operator= (_Inout_ window_dc &&h) noexcept
virtual | ~window_dc ()
| Releases a device context (DC), freeing it for use by other applications. More...
Public Member Functions inherited from winstd::handle< HDC, NULL >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (_In_opt_ handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| handle (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
handle< handle_type, INVAL > & | operator= (_In_opt_ handle_type h) noexcept
| Attaches already available object handle. More...
handle< handle_type, INVAL > & | operator= (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move assignment. More...
| operator handle_type () const
| Auto-typecasting operator. More...
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.). More...
handle_type * | operator& ()
| Returns the object handle reference. More...
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct. More...
bool | operator! () const
| Tests if the object handle is INVAL. More...
bool | operator< (_In_opt_ handle_type h) const
| Is handle less than? More...
bool | operator<= (_In_opt_ handle_type h) const
| Is handle less than or equal to? More...
bool | operator>= (_In_opt_ handle_type h) const
| Is handle greater than or equal to? More...
bool | operator> (_In_opt_ handle_type h) const
| Is handle greater than? More...
bool | operator!= (_In_opt_ handle_type h) const
| Is handle not equal to? More...
bool | operator== (_In_opt_ handle_type h) const
| Is handle equal to? More...
void | attach (_In_opt_ handle_type h) noexcept
| Sets a new object handle for the class. More...
handle_type | detach ()
| Dismisses the object handle from this class. More...
void | free ()
| Destroys the object.

## Protected Member Functions
void | free_internal () noexcept override
| Releases a device context (DC), freeing it for use by other applications. More...
virtual void | free_internal () noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object destruction. More...

## Protected Attributes
HWND | m_hwnd
| Window handle.
Protected Attributes inherited from winstd::handle< HDC, NULL >
handle_type | m_h
| Object handle.

## Additional Inherited Members
Public Types inherited from winstd::handle< HDC, NULL >
typedef HDC | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< HDC, NULL >
static const HDC | invalid
| Invalid handle value.

## Detailed Description

Device context wrapper class.

## Constructor & Destructor Documentation

## ◆ ~window_dc()

virtual winstd::window_dc::~window_dc | ( |  | ) |
| inline virtual

Releases a device context (DC), freeing it for use by other applications.

See also
  ReleaseDC function

## Member Function Documentation

## ◆ free_internal()

void winstd::window_dc::free_internal | ( |  | ) |
| inline override protected virtual noexcept

Releases a device context (DC), freeing it for use by other applications.

See also
  ReleaseDC function

Implements winstd::handle< HDC, NULL >.

The documentation for this class was generated from the following file:

- include/WinStd/GDI.h